---------------------------------------------------------------------------
--                                                                       --
--  Ast2Cfg is an ASIS application that generates a CFG out of the AST.  --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--     Copyright (c) 2007, 2008, 2009 Raul Fechete, Georg Kienesberger   --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
-- This file is part of Ast2Cfg.                                         --
--                                                                       --
-- Ast2Cfg is free software; you can redistribute it and/or modify       --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 3 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- Ast2Cfg is distributed in the hope that it will be useful,            --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with this program.  If not, see <http://www.gnu.org/licenses/>. --
--                                                                       --
---------------------------------------------------------------------------

with Asis;
with Asis.Elements; use Asis.Elements;
with Asis.Ada_Environments;
with Asis.Implementation;
with Asis.Exceptions;
with Asis.Errors;

with Ast2Cfg.Flow_World;
use Ast2Cfg;

package Ast2Cfg.Control is

   procedure Init (Context_Parameters: in Wide_String := "";
                   Interprocedural: in Boolean := False;
                   Compress_Param_Trees: in Boolean := True);
   function Generate return Flow_World.World_Object_Ptr;
   procedure Final;

private
   My_Context            : Asis.Context;
   My_Context_Name       : Wide_String := Asis.Ada_Environments.Default_Name;
   My_Context_Parameters : Wide_String := Asis.Ada_Environments.Default_Parameters;
   Initialization_Parameters : Wide_String := "";
   Finalization_Parameters   : Wide_String := "";

   Interprocedural      : Boolean := False;
   Compress_Param_Trees : Boolean := True;

   World: Ast2Cfg.Flow_World.World_Object_Ptr := null;

end Ast2Cfg.Control;
