---------------------------------------------------------------------------
--                                                                       --
--  Ast2Cfg is an ASIS application that generates a CFG out of the AST.  --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--     Copyright (c) 2007, 2008, 2009 Raul Fechete, Georg Kienesberger   --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
-- This file is part of Ast2Cfg.                                         --
--                                                                       --
-- Ast2Cfg is free software; you can redistribute it and/or modify       --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 3 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- Ast2Cfg is distributed in the hope that it will be useful,            --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with this program.  If not, see <http://www.gnu.org/licenses/>. --
--                                                                       --
---------------------------------------------------------------------------

with Ada.Strings.Fixed;
with Ada.Strings.Hash;

package body Ast2Cfg.Declaration_Id is
   
   procedure Init (O: in out Object) is
   begin
      Last_Id := Last_Id + 1;
      O.Id := Last_Id;
   end Init;

   function "="(Left: in Object; Right: in Object) return Boolean is
   begin
      if Left.Id = Right.Id then
         return True;
      else
         return False;
      end if;
   end "=";

   function "<" (Left: in Object; Right: in Object) return Boolean is
   begin
      if Left.Id < Right.Id then
         return True;
      else
         return False;
      end if;
   end "<";

   function ">" (Left: in Object; Right: in Object) return Boolean is
   begin
      if Left.Id > Right.Id then
         return True;
      else
         return False;
      end if;
   end ">";

   function To_String (O: in Object) return String is
   begin
      return Ada.Strings.Fixed.Trim(Long_Long_Natural'Image(O.Id), Ada.Strings.Both);
   end To_String;
   
   function Hash (O: in Object) return Ada.Containers.Hash_Type is
   begin
      return Ada.Strings.Hash(To_String(O));
   end Hash;
   
end Ast2Cfg.Declaration_Id;
